--- old/usr/src/tools/smatch/src/smatch.c	Mon Aug  5 08:38:12 2019
+++ new/usr/src/tools/smatch/src/smatch.c	Mon Aug  5 08:38:12 2019
@@ -21,6 +21,7 @@
 #include <unistd.h>
 #include <libgen.h>
 #include "smatch.h"
+#include "smatch_slist.h"
 #include "check_list.h"
 
 char *option_debug_check = (char *)"";
@@ -38,7 +39,6 @@
 int option_no_db = 0;
 int option_enable = 0;
 int option_disable = 0;
-int option_debug_related;
 int option_file_output;
 int option_time;
 int option_mem;
@@ -176,7 +176,7 @@
 }
 
 #define OPTION(_x) do {					\
-	if (match_option((*argvp)[i], #_x)) { 		\
+	if (match_option((*argvp)[1], #_x)) { 		\
 		option_##_x = 1;			\
 	}                                               \
 } while (0)
@@ -231,8 +231,6 @@
 		OPTION(spammy);
 		OPTION(info);
 		OPTION(debug);
-		OPTION(debug_implied);
-		OPTION(debug_related);
 		OPTION(assume_loops);
 		OPTION(no_data);
 		OPTION(two_passes);
@@ -322,6 +320,7 @@
 
 int main(int argc, char **argv)
 {
+	struct string_list *filelist = NULL;
 	int i;
 	reg_func func;
 
@@ -343,8 +342,12 @@
 	data_dir = get_data_dir(argv[0]);
 
 	allocate_hook_memory();
+	allocate_dynamic_states_array(num_checks);
 	create_function_hook_hash();
 	open_smatch_db(option_db_file);
+	sparse_initialize(argc, argv, &filelist);
+	alloc_valid_ptr_rl();
+
 	for (i = 1; i < ARRAY_SIZE(reg_funcs); i++) {
 		func = reg_funcs[i].func;
 		/* The script IDs start at 1.
@@ -355,7 +358,7 @@
 			func(i);
 	}
 
-	smatch(argc, argv);
+	smatch(filelist);
 	free_string(data_dir);
 
 	if (option_succeed)
